From 1fa68c56587947116f7105aff5b27d55b20986d6 Mon Sep 17 00:00:00 2001
From: Ondrej Kos <okos@redhat.com>
Date: Mon, 9 Sep 2013 16:03:23 +0200
Subject: [PATCH] MAN: Remove IPA specific LDAP settings

Resolves:
https://fedorahosted.org/sssd/ticket/1187
---
 src/man/sssd-ipa.5.xml | 218 -------------------------------------------------
 1 file changed, 218 deletions(-)

diff --git a/src/man/sssd-ipa.5.xml b/src/man/sssd-ipa.5.xml
index 894a61fa6fd3e4615c61d88a3c18016ae750288c..667920edcaad07caff63bf872a74b322c5fba437 100644
--- a/src/man/sssd-ipa.5.xml
+++ b/src/man/sssd-ipa.5.xml
@@ -483,224 +483,6 @@
                         <xi:include xmlns:xi="http://www.w3.org/2001/XInclude" href="include/autofs_restart.xml" />
                     </listitem>
                 </varlistentry>
-
-                <varlistentry>
-                    <term>ipa_netgroup_member_of (string)</term>
-                    <listitem>
-                        <para>
-                            The LDAP attribute that lists netgroup's
-                            memberships.
-                        </para>
-                        <para>
-                            Default: memberOf
-                        </para>
-                    </listitem>
-                </varlistentry>
-                <varlistentry>
-                    <term>ipa_netgroup_member_user (string)</term>
-                    <listitem>
-                        <para>
-                            The LDAP attribute that lists system users
-                            and groups that are direct members of the
-                            netgroup.
-                        </para>
-                        <para>
-                            Default: memberUser
-                        </para>
-                    </listitem>
-                </varlistentry>
-                <varlistentry>
-                    <term>ipa_netgroup_member_host (string)</term>
-                    <listitem>
-                        <para>
-                            The LDAP attribute that lists hosts and host groups
-                            that are direct members of the netgroup.
-                        </para>
-                        <para>
-                            Default: memberHost
-                        </para>
-                    </listitem>
-                </varlistentry>
-                <varlistentry>
-                    <term>ipa_netgroup_member_ext_host (string)</term>
-                    <listitem>
-                        <para>
-                            The LDAP attribute that lists FQDNs of hosts
-                            and host groups that are members of the netgroup.
-                        </para>
-                        <para>
-                            Default: externalHost
-                        </para>
-                    </listitem>
-                </varlistentry>
-                <varlistentry>
-                    <term>ipa_netgroup_domain (string)</term>
-                    <listitem>
-                        <para>
-                            The LDAP attribute that contains NIS domain
-                            name of the netgroup.
-                        </para>
-                        <para>
-                            Default: nisDomainName
-                        </para>
-                    </listitem>
-                </varlistentry>
-
-                <varlistentry>
-                    <term>ipa_host_object_class (string)</term>
-                    <listitem>
-                        <para>
-                            The object class of a host entry in LDAP.
-                        </para>
-                        <para>
-                            Default: ipaHost
-                        </para>
-                    </listitem>
-                </varlistentry>
-                <varlistentry>
-                    <term>ipa_host_fqdn (string)</term>
-                    <listitem>
-                        <para>
-                            The LDAP attribute that contains FQDN of the host.
-                        </para>
-                        <para>
-                            Default: fqdn
-                        </para>
-                    </listitem>
-                </varlistentry>
-
-                <varlistentry>
-                    <term>ipa_selinux_usermap_object_class (string)</term>
-                    <listitem>
-                        <para>
-                            The object class of a host entry in LDAP.
-                        </para>
-                        <para>
-                            Default: ipaHost
-                        </para>
-                    </listitem>
-                </varlistentry>
-                <varlistentry>
-                    <term>ipa_selinux_usermap_name (string)</term>
-                    <listitem>
-                        <para>
-                            The LDAP attribute that contains the name
-                            of SELinux usermap.
-                        </para>
-                        <para>
-                            Default: cn
-                        </para>
-                    </listitem>
-                </varlistentry>
-                <varlistentry>
-                    <term>ipa_selinux_usermap_member_user (string)</term>
-                    <listitem>
-                        <para>
-                            The LDAP attribute that contains all users / groups
-                            this rule match against.
-                        </para>
-                        <para>
-                            Default: memberUser
-                        </para>
-                    </listitem>
-                </varlistentry>
-                <varlistentry>
-                    <term>ipa_selinux_usermap_member_host (string)</term>
-                    <listitem>
-                        <para>
-                            The LDAP attribute that contains all hosts / hostgroups
-                            this rule match against.
-                        </para>
-                        <para>
-                            Default: memberHost
-                        </para>
-                    </listitem>
-                </varlistentry>
-                <varlistentry>
-                    <term>ipa_selinux_usermap_see_also (string)</term>
-                    <listitem>
-                        <para>
-                            The LDAP attribute that contains DN of HBAC
-                            rule which can be used for matching instead
-                            of memberUser and memberHost
-                        </para>
-                        <para>
-                            Default: seeAlso
-                        </para>
-                    </listitem>
-                </varlistentry>
-                <varlistentry>
-                    <term>ipa_selinux_usermap_selinux_user (string)</term>
-                    <listitem>
-                        <para>
-                            The LDAP attribute that contains SELinux user
-                            string itself.
-                        </para>
-                        <para>
-                            Default: ipaSELinuxUser
-                        </para>
-                    </listitem>
-                </varlistentry>
-                <varlistentry>
-                    <term>ipa_selinux_usermap_enabled (string)</term>
-                    <listitem>
-                        <para>
-                            The LDAP attribute that contains whether
-                            or not is user map enabled for usage.
-                        </para>
-                        <para>
-                            Default: ipaEnabledFlag
-                        </para>
-                    </listitem>
-                </varlistentry>
-                <varlistentry>
-                    <term>ipa_selinux_usermap_user_category (string)</term>
-                    <listitem>
-                        <para>
-                            The LDAP attribute that contains user category
-                            such as 'all'.
-                        </para>
-                        <para>
-                            Default: userCategory
-                        </para>
-                    </listitem>
-                </varlistentry>
-                <varlistentry>
-                    <term>ipa_selinux_usermap_host_category (string)</term>
-                    <listitem>
-                        <para>
-                            The LDAP attribute that contains host category
-                            such as 'all'.
-                        </para>
-                        <para>
-                            Default: hostCategory
-                        </para>
-                    </listitem>
-                </varlistentry>
-                <varlistentry>
-                    <term>ipa_selinux_usermap_uuid (string)</term>
-                    <listitem>
-                        <para>
-                            The LDAP attribute that contains unique ID
-                            of the user map.
-                        </para>
-                        <para>
-                            Default: ipaUniqueID
-                        </para>
-                    </listitem>
-                </varlistentry>
-                <varlistentry condition="with_ssh">
-                    <term>ipa_host_ssh_public_key (string)</term>
-                    <listitem>
-                        <para>
-                            The LDAP attribute that contains the host's SSH
-                            public keys.
-                        </para>
-                        <para>
-                            Default: ipaSshPubKey
-                        </para>
-                    </listitem>
-                </varlistentry>
             </variablelist>
         </para>
     </refsect1>
-- 
1.8.1.4